Attribute VB_Name = "Module"
Option Explicit
Public Const DT_CALCRECT = &H400
Public Type RECT
  Left As Long
  Top As Long
  Right As Long
  Bottom As Long
End Type
Public Type Size
  cx As Long  ' 
  cy As Long  ' 
End Type

Declare Function TextOut Lib "gdi32" Alias "TextOutA" (ByVal hDC As _
         Long, ByVal X As Long, ByVal Y As Long, lpString As Any, _
         ByVal nCount As Long) As Long

Declare Function DrawText Lib "user32" Alias "DrawTextA" (ByVal hDC As Long, ByVal lpStr As String, ByVal nCount As Long, lpRect As RECT, ByVal wFormat As Long) As Long

Declare Function GetTextExtentPoint32 Lib "gdi32" Alias "GetTextExtentPoint32A" _
(ByVal hDC As Long, ByVal lpsz As String, ByVal cbString As Long, lpSize As Size) As Long
' lpsz = ւ̃|C^, cbString = ̒
' lpsize = ƍ.
  
Public UseDrawText As Long
Public Const DrawTextAPI As Long = 1, GetTextExtentAPI As Long = 0
Dim Bts() As Byte

'===============================================================
' BpQƒ` (HTML ̎QƂɏ]).
' 2009/Dec/ boco_san (http://hp.vector.co.jp/authors/VA051022/)
Public Ref(255) As String

Sub DefRefHTML(Ref() As String)
  Dim A(15) As String, iHigh As Long, iLow As Long
  Dim j As Long, S As String, Rf As String
' ----- tHgQƖ̒` -----
  A(8) = "euro,81,sbquo,fnof,dbquo,hellip,dagger,Dagger,circ,permille,Scaron,lsaquo,OElig,8D,Zcaron,8F"
  A(9) = "90,lsquo,rsquo,ldquo,rdquo,bull,minus,mdash,tilde,trade,scaron,rsaquo,oelig,9D,zcaron,Yuml"
  A(10) = "nbsp,iexcl,cent,pound,curren,yen,brvbar,sect,uml,copy,ordf,laquo,not,shy,reg,macr"
  A(11) = "deg,plusmn,sup2,sup3,acute,micro,para,middot,cedil,sup1,ordm,raquo,frac14,frac12,frac34,iquest"
  A(12) = "Agrave,Aacute,Acirc,Atilde,Auml,Aring,AElig,Ccedil,Egrave,Eacute,Ecirc,Euml,Igrave,Iacute,Icirc,Iuml"
  A(13) = "ETH,Ntilde,Ograve,Oacute,Ocirc,Otilde,Ouml,mult,Oslash,Ugrave,Uacute,Ucirc,Uuml,Yacute,THORN,szlig"
  A(14) = "agrave,aacute,acirc,atilde,auml,aring,aelig,ccedil,egrave,eacute,ecirc,euml,igrave,iacute,icirc,iuml"
  A(15) = "eth,ntilde,ograve,oacute,ocirc,otilde,ouml,divide,oslash,ugrave,uacute,ucirc,uuml,yacute,thorn,yuml"
  
  For iHigh = 8 To 15
    iLow = 0
   S = A(iHigh)
    Do While Len(S)
      j = InStr(S, ",")
      If j Then
        Rf = Left(S, j - 1): S = Mid(S, j + 1)
      Else
        Rf = S: S = ""
      End If
      If Len(Rf) Then Ref(iHigh * 16 + iLow) = Rf
      iLow = iLow + 1
    Loop
  Next
End Sub

' Ƃ΁C "Qu&eacute;"  oCg "51 75 E9" ɕϊ.
' ŁCe[u@Ref() g.
Sub ConvStrgToBytes(Bts() As Byte, L As Long, ByVal Strg As String)
  Dim j As Long, k As Long, CodeNo As Long
  Dim S As String, St As String
  L = 0
  S = Strg
  Do While Len(S)
    j = InStr(S, "&")
    Select Case j
    Case 1
      k = InStr(S, ";")
      If k = 0 Then
        S = Mid(S, 2)
      Else
        St = Mid(S, 2, k - 2): S = Mid(S, k + 1)
        Select Case St
        Case "nbsp"
          CodeNo = &H20: GoSub AddThis
        Case "quot"
          CodeNo = &H22: GoSub AddThis
        Case "amp"
          CodeNo = &H26: GoSub AddThis
        Case Else
          For CodeNo = &H80 To &HFF
            If Ref(CodeNo) = St Then GoSub AddThis: Exit For
          Next
        End Select
      End If
    Case Else
      If j = 0 Then
        St = S: S = ""
      Else
        St = Left(S, j - 1): S = Mid(S, j)
      End If
      For k = 1 To Len(St)
        CodeNo = Asc(Mid(St, k, 1))
        Select Case CodeNo
        Case &H20 To &H7F
          GoSub AddThis
        End Select
      Next
    End Select
  Loop
Exit Sub

AddThis:
  L = L + 1
  Bts(L) = CodeNo
Return
End Sub

' 16 i̕ "20 7A" Ȃǂ Strg  oCg Bts() 𐶐.
Sub GenerateByteSequence(Bts() As Byte, LenBts As Long, ByVal Strg As String)
  Dim S As String, St As String, j As Long, L As Long, V As Long
  S = Strg
  Do While Len(S)
    j = InStr(S, " ")
    If j Then
      St = Trim(Left(S, j - 1)): S = Trim(Mid(S, j + 1))
    Else
      St = S: S = ""
    End If
    V = Val("&H" & St)
    Select Case V
    Case &H20 To &HFF
      L = L + 1
      Bts(L) = Val("&H" & St)
    End Select
  Loop
  LenBts = L
End Sub

' HTML `ŏꂽ Strg CIuWFNg Obj ̈ʒu (X,Y) ɕ\.
' \́CX ̒li. (CurrentX Ɠlł).
Sub PutString(Obj As Object, ByVal Strg As String, X As Long, Y As Long)
  Dim j As Long, k As Long, L As Long, CodeNo As Long
  Dim S As String, St As String
  ReDim Bts(Len(Strg) * 2) As Byte
'  oCgɕϊĂCSUB PutBytes() Ăяo.
  If Len(Strg) Then
    Call ConvStrgToBytes(Bts(), L, Strg)
    Call PutBytes(Obj, X, Y, Bts(1), L)
  End If
End Sub

' \镶̃TCYiƍj𓾂.
Sub txtWdHt(Obj As Object, ByVal Strg As String, txtWidth As Long, txtHeight As Long)
  Dim X As Long, Y As Long       ' Dummy variables
  Dim Bytes() As Byte, L As Long
  Dim OutPutSize As Size
  Call ConvStrgToBytes(Bytes(), L, Strg)
  Call ProcPutBytes(Obj, X, Y, Bytes(1), L, OutPutSize, 0)
  txtWidth = OutPutSize.cx
  txtHeight = OutPutSize.cy
End Sub

' LƓ. CoCg͂̏ꍇ.
Sub byteWdHt(Obj As Object, Bytes As Byte, ByVal L As Long, txtWidth As Long, txtHeight As Long)
  Dim X As Long, Y As Long       ' Dummy variables
  Dim OutPutSize As Size
  Call ProcPutBytes(Obj, X, Y, Bytes, L, OutPutSize, 0)
  txtWidth = OutPutSize.cx
  txtHeight = OutPutSize.cy
End Sub

Sub PutBytes(Obj As Object, X As Long, Y As Long, ByRef Bytes As Byte, ByVal L As Long)
  Dim OutPutSize As Size
  Call ProcPutBytes(Obj, X, Y, Bytes, L, OutPutSize, 1)
  X = X + OutPutSize.cx
  End Sub

' ꂪC{ SUB ł.
' R[h Chr() œn &H80`&HFF ̂ƂɕN.
' 邽߂ɁCByte ŃR[hn.
' Mode = 0 ł̌ĂяóCTCY𓾂邽߂ŁC\͂Ȃ.
' Mode = 1 ł̌ĂяóCTCY𓾂Ɠɕ\.
Sub ProcPutBytes(Obj As Object, X As Long, Y As Long, _
  Bytes As Byte, ByVal ByteLength As Long, OutPutSize As Size, ByVal Mode As Long)
  Dim REC As RECT
  Dim hDC As Long
  Dim xt As Long
  
  hDC = Obj.hDC

' Mode = 0 ̏ꍇɂ́CeLXg Width, Height 𓾂邾ŁC\Ȃ.
  If Mode Then xt = TextOut(hDC, X, Y, Bytes, ByteLength)

  If UseDrawText Then
    Call DrawText(hDC, Bytes, ByteLength, REC, DT_CALCRECT)
    OutPutSize.cx = REC.Right - REC.Left
    OutPutSize.cy = REC.Bottom - REC.Top
  Else
    Call GetTextExtentPoint32(hDC, Bytes, ByteLength, OutPutSize)
  End If
End Sub
'===========================================================================
